--------------------------------------------------------------------------
--------------------------------------------------------------------------
---  circuito tb
--------------------------------------------------------------------------
--------------------------------------------------------------------------
library IEEE;
use IEEE.Std_Logic_1164.all;
use IEEE.Std_Logic_unsigned.all;   -- uso conv_integer
use IEEE.Std_Logic_arith.all;
 
entity tb is
 end tb;
        

architecture tb of tb is
                                      
   signal ck, reset : std_logic;
   signal LEDG, halt : std_logic; -- added by Ney to conform to new interfaces signals
   				 -- for D2SB/DIO4 prototyping board
   signal an :  std_logic_vector(4 downto 1);
   signal dec_ddp, dipsw, leds : std_logic_vector(7 downto 0);

begin


   UUT : entity work.top port map
               ( ck=>ck, reset=>reset, an=>an, dec_ddp=>dec_ddp, halt=>halt,
               LEDG=>LEDG, leds=>leds, dipsw=>dipsw);
  
   reset <= '1', '0' after 5 ns,  '1' after 150 ns, '0' after 250 ns;
         
   process
            begin
             ck <= '1', '0' after 20 ns;
             wait for 40 ns;
   end process;
   -- Ney: clock frequency changed to conform exactly to implementation, 25MHz

               
end tb;
