;	Programa que soma 2 numeros de 16 bits e depois faz entrada/sada 
;	Cada nmero  armazenado em dua posies de memria (N1h-N1l e 
;		N2h-N2l). O resultado  armazenado em trs posies de
; 		memria (CY e Rh-Rl)
;
;               N1h N1l
;           +   N2h N2l
;              --------
;            CY  Rh  Rl
;
.code
	lda	N1h		; soma primeiro as partes altas
	add	N2h
	sta	Rh		; guarda na parte alta do resultado.
				; esta pode mudar se houver carry da parte baixa
	jc	carry1		; se deu carry da parte alta, seta CY para 1

volta:	lda	N1l		; agora soma partes baixas
	add	N2l
	sta	Rl		; guarda na parte baixa do resultado. 
	jc	carry,R		; se deu carry, vai adicionar 1 a Rh
	jmp	exibe,R

carry:	lda	Rh		; deu carry da parte baixa, soma 1 a Rh
	add	#01h
	sta	Rh

exibe:	lda	Rl
	sta	0FFH		; escreve nos 2 displays mais  direita a parte baixa

	lda	Rh
	sta	0FEH		; escreve nos 2 displays mais  esquerda a parte alta
         
	lda 	0FDH		; agora, l as chaves deslizantes
	sta 	0FDH		; e armazena o valor lido nos leds
	jz  	fim,R		; quando tiver 0 nas chaves  a condio para terminar a execucao

	jsr 	tempo,R		; seno, chama rotina para passar um tempo, adequando o clock
				; do processador  lentido das aes externas (mover chaves,
				; mostrar dados nos displays)

	lda	Rl		; depois de passar o tempo, incrementa Rl
	add	#1
	sta	Rl	
	jc	inchigh		; vai incrementar parte alta
	jmp	exibe, R	; seno, volta a esperar o tempo para aparecer novo valor
         			; do contador
inchigh:lda	Rh		; se deu vai um, incrmenta parte alta tambm 
	add	#1
	sta	Rh
	jmp	exibe,R		; e volta a exibir

fim:     hlt			; fim do programa


carry1:  lda	#01h
         sta	CY
         jmp	volta
;
;  Rotina que espera um tempo equivalente a aproximadamente (tt*(2*tt)) ciclos de relgio
;
tempo:   lda	tt         
         sta	t1		; initialize t1 counter to tt(255)
ltime:   lda	t1		; load t1 counter
         add	#0FFH
         sta	t1		; decrement it
         jz	f4,R		; end if arrived at 0

	lda	tt		; else, initialize AC with tt(255)
f1:	add	#0FFH		; count until 0
	jz	f2,R		; then, go to f2
	jmp	f1,R 		

f2:	lda	tt		; here, initialize AC again with tt(255)
f3:	add	#0FFH		; count until 0
	jz	f5,R		; then, go to f5
	jmp	f3,R 
    
f5:	jmp	ltime,R
f4:	rts
         
.endcode

.data

CY:	db	#00H
N1h:	db	#3FH
N1l:	db	#84H
N2h:	db	#3EH
N2l:	db	#0CAH
Rh:	db	#00H
Rl:	db	#00H
t1:	db	#00H
tt:	db	#0FFH 

.enddata

